DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Data Grid - Toolbar

The JavaScript DataGrid includes an integrated toolbar that displays predefined and custom controls. To add or remove toolbar items, declare the toolbar.items[] array.

If toolbar.items[] is specified, JavaScript DataGrid does not display controls missing from the array. Ensure this array includes controls for all enabled features.

Backend API
$(() => { const dataGrid = $('#gridContainer').dxDataGrid({ dataSource: orders, keyExpr: 'ID', showBorders: true, columnChooser: { enabled: true, }, loadPanel: { enabled: true, }, columns: [{ dataField: 'OrderNumber', caption: 'Invoice Number', }, 'OrderDate', 'Employee', { caption: 'City', dataField: 'CustomerStoreCity', }, { caption: 'State', groupIndex: 0, dataField: 'CustomerStoreState', }, { dataField: 'SaleAmount', alignment: 'right', format: 'currency', }], toolbar: { items: [ { location: 'before', template() { return $('<div>') .addClass('informer') .append( $('<div>') .addClass('count') .text(getGroupCount('CustomerStoreState')), $('<span>') .text('Total Count'), ); }, }, { location: 'before', locateInMenu: 'auto', widget: 'dxSelectBox', options: { width: 225, items: [{ value: 'CustomerStoreState', text: 'Grouping by State', }, { value: 'Employee', text: 'Grouping by Employee', }], displayExpr: 'text', valueExpr: 'value', value: 'CustomerStoreState', onValueChanged(e) { dataGrid.clearGrouping(); dataGrid.columnOption(e.value, 'groupIndex', 0); $('.informer .count').text(getGroupCount(e.value)); }, }, }, { location: 'before', locateInMenu: 'auto', widget: 'dxButton', options: { text: 'Collapse All', width: 136, onClick(e) { const expanding = e.component.option('text') === 'Expand All'; dataGrid.option('grouping.autoExpandAll', expanding); e.component.option('text', expanding ? 'Collapse All' : 'Expand All'); }, }, }, { location: 'after', locateInMenu: 'auto', showText: 'inMenu', widget: 'dxButton', options: { icon: 'refresh', text: 'Refresh', onClick() { dataGrid.refresh(); }, }, }, 'columnChooserButton', ], }, }).dxDataGrid('instance'); function getGroupCount(groupField) { return DevExpress.data.query(orders) .groupBy(groupField) .toArray().length; } });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.4"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="gridContainer"></div> </div> </body> </html>
#gridContainer .informer { display: grid; width: 120px; grid-template-columns: 100%; padding-right: 20px; text-align: center; } #gridContainer .count { font-size: 18px; font-weight: 500; } #gridContainer .dx-toolbar-items-container { min-height: 44px; }
const orders = [{ ID: 1, OrderNumber: 35703, OrderDate: new Date(2024, 3, 10), SaleAmount: 11800, Terms: '15 Days', TotalAmount: 12175, CustomerStoreState: 'California', CustomerStoreCity: 'Los Angeles', Employee: 'Harv Mudd', }, { ID: 4, OrderNumber: 35711, OrderDate: new Date(2024, 0, 12), SaleAmount: 16050, Terms: '15 Days', TotalAmount: 16550, CustomerStoreState: 'California', CustomerStoreCity: 'San Jose', Employee: 'Jim Packard', }, { ID: 5, OrderNumber: 35714, OrderDate: new Date(2024, 0, 22), SaleAmount: 14750, Terms: '15 Days', TotalAmount: 15250, CustomerStoreState: 'Nevada', CustomerStoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { ID: 7, OrderNumber: 35983, OrderDate: new Date(2024, 1, 7), SaleAmount: 3725, Terms: '15 Days', TotalAmount: 3850, CustomerStoreState: 'Colorado', CustomerStoreCity: 'Denver', Employee: 'Todd Hoffman', }, { ID: 9, OrderNumber: 36987, OrderDate: new Date(2024, 2, 11), SaleAmount: 14200, Terms: '15 Days', TotalAmount: 14800, CustomerStoreState: 'Utah', CustomerStoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { ID: 11, OrderNumber: 38466, OrderDate: new Date(2024, 2, 1), SaleAmount: 7800, Terms: '15 Days', TotalAmount: 8200, CustomerStoreState: 'California', CustomerStoreCity: 'Los Angeles', Employee: 'Harv Mudd', }, { ID: 14, OrderNumber: 39420, OrderDate: new Date(2024, 1, 15), SaleAmount: 20500, Terms: '15 Days', TotalAmount: 9100, CustomerStoreState: 'California', CustomerStoreCity: 'San Jose', Employee: 'Jim Packard', }, { ID: 15, OrderNumber: 39874, OrderDate: new Date(2024, 1, 4), SaleAmount: 9050, Terms: '30 Days', TotalAmount: 19100, CustomerStoreState: 'Nevada', CustomerStoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { ID: 18, OrderNumber: 42847, OrderDate: new Date(2024, 1, 15), SaleAmount: 20400, Terms: '30 Days', TotalAmount: 20800, CustomerStoreState: 'Wyoming', CustomerStoreCity: 'Casper', Employee: 'Todd Hoffman', }, { ID: 19, OrderNumber: 43982, OrderDate: new Date(2024, 4, 29), SaleAmount: 6050, Terms: '30 Days', TotalAmount: 6250, CustomerStoreState: 'Utah', CustomerStoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { ID: 29, OrderNumber: 56272, OrderDate: new Date(2024, 1, 6), SaleAmount: 15850, Terms: '30 Days', TotalAmount: 16350, CustomerStoreState: 'Utah', CustomerStoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { ID: 30, OrderNumber: 57429, OrderDate: new Date(2023, 11, 31), SaleAmount: 11050, Terms: '30 Days', TotalAmount: 11400, CustomerStoreState: 'Arizona', CustomerStoreCity: 'Phoenix', Employee: 'Clark Morgan', }];

This demo illustrates how to add the following items to the toolbar:

  • Predefined Controls
    Create an object and specify the name and properties that you want to customize. If a control does not need customization, include its name in the items[] array. Ensure that items[] contain controls for all features that you enabled in your JavaScript DataGrid. In this demo, we enable the columnChooser and add the "columnChooserButton" to the items[] array.

  • DevExtreme Components
    Specify a widget that you want to add and its options. In this demo, we extended the toolbar's item collection with a Button and a SelectBox.

  • Custom Elements
    Specify a template for your custom element. In this demo, the custom element displays the total group count.

<template>
<DxDataGrid
id="gridContainer"
ref="dataGridRef"
:data-source="orders"
key-expr="ID"
:show-borders="true"
>
<DxGrouping :auto-expand-all="expandAll"/>
<DxColumnChooser :enabled="true"/>
<DxLoadPanel :enabled="true"/>
<DxColumn
data-field="OrderNumber"
caption="Invoice Number"
/>
<DxColumn data-field="OrderDate"/>
<DxColumn data-field="Employee"/>
<DxColumn
data-field="CustomerStoreCity"
caption="City"
/>
<DxColumn
:group-index="0"
data-field="CustomerStoreState"
caption="State"
/>
<DxColumn
data-field="SaleAmount"
alignment="right"
format="currency"
/>
<DxToolbar>
<DxItem
location="before"
template="totalCountTemplate"
/>
<DxItem
location="before"
locateInMenu="auto"
template="groupingTemplate"
/>
<DxItem
location="before"
locateInMenu="auto"
widget="dxButton"
:options="toggleButtonOptions"
/>
<DxItem
location="after"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
:options="refreshButtonOptions"
/>
<DxItem
name="columnChooserButton"
/>
</DxToolbar>
<template #totalCountTemplate>
<div class="informer">
<div class="count">{{ totalCount }}</div>
<span>Total Count</span>
</div>
</template>
<template #groupingTemplate>
<DxSelectBox
width="225"
:items="groupingValues"
:input-attr="{ 'aria-label': 'Group' }"
display-expr="text"
value-expr="value"
value="CustomerStoreState"
@value-changed="toggleGroupColumn"
/>
</template>
</DxDataGrid>
</template>
<script setup lang="ts">
import { computed, ref } from 'vue';
import {
DxDataGrid,
DxColumn,
DxGrouping,
DxColumnChooser,
DxLoadPanel,
DxToolbar,
DxItem,
} from 'devextreme-vue/data-grid';
import { DxSelectBox, type DxSelectBoxTypes } from 'devextreme-vue/select-box';
import { query } from 'devextreme-vue/common/data';
import { orders } from './data.ts';
const getGroupCount = (groupField: string) => query(orders)
.groupBy(groupField)
.toArray().length;
const dataGridRef = ref<DxDataGrid | null>(null);
const expandAll = ref(true);
const totalCount = ref(getGroupCount('CustomerStoreState'));
const groupingValues = [{
value: 'CustomerStoreState',
text: 'Grouping by State',
}, {
value: 'Employee',
text: 'Grouping by Employee',
}];
const toggleGroupColumn = (e: DxSelectBoxTypes.ValueChangedEvent) => {
dataGridRef.value!.instance!.clearGrouping();
dataGridRef.value!.instance!.columnOption(e.value, 'groupIndex', 0);
totalCount.value = getGroupCount(e.value);
};
const toggleExpandAll = () => {
expandAll.value = !expandAll.value;
};
const toggleButtonOptions = computed(() => ({
text: expandAll.value ? 'Collapse All' : 'Expand All',
width: 136,
onClick: toggleExpandAll,
}));
const refreshButtonOptions = {
icon: 'refresh',
text: 'Refresh',
onClick: () => {
dataGridRef.value!.instance!.refresh();
},
};
</script>
<style>
#gridContainer .informer {
display: grid;
width: 120px;
grid-template-columns: 100%;
padding-right: 20px;
text-align: center;
}
#gridContainer .count {
font-size: 18px;
font-weight: 500;
}
#gridContainer .dx-toolbar-items-container {
min-height: 44px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export type Order = {
ID: number;
OrderNumber: number;
OrderDate: Date;
SaleAmount: number;
Terms: string;
TotalAmount: number;
CustomerStoreState: string;
CustomerStoreCity: string;
Employee: string;
};
export const orders: Order[] = [{
ID: 1,
OrderNumber: 35703,
OrderDate: new Date(2024, 3, 10),
SaleAmount: 11800,
Terms: '15 Days',
TotalAmount: 12175,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: new Date(2024, 0, 12),
SaleAmount: 16050,
Terms: '15 Days',
TotalAmount: 16550,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: new Date(2024, 0, 22),
SaleAmount: 14750,
Terms: '15 Days',
TotalAmount: 15250,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: new Date(2024, 1, 7),
SaleAmount: 3725,
Terms: '15 Days',
TotalAmount: 3850,
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: new Date(2024, 2, 11),
SaleAmount: 14200,
Terms: '15 Days',
TotalAmount: 14800,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: new Date(2024, 2, 1),
SaleAmount: 7800,
Terms: '15 Days',
TotalAmount: 8200,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: new Date(2024, 1, 15),
SaleAmount: 20500,
Terms: '15 Days',
TotalAmount: 9100,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: new Date(2024, 1, 4),
SaleAmount: 9050,
Terms: '30 Days',
TotalAmount: 19100,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: new Date(2024, 1, 15),
SaleAmount: 20400,
Terms: '30 Days',
TotalAmount: 20800,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: new Date(2024, 4, 29),
SaleAmount: 6050,
Terms: '30 Days',
TotalAmount: 6250,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: new Date(2024, 1, 6),
SaleAmount: 15850,
Terms: '30 Days',
TotalAmount: 16350,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: new Date(2023, 11, 31),
SaleAmount: 11050,
Terms: '30 Days',
TotalAmount: 11400,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>

<dx-data-grid
id="gridContainer"
[dataSource]="orders"
keyExpr="ID"
[showBorders]="true"
>
<dxo-data-grid-grouping [autoExpandAll]="expandAll"></dxo-data-grid-grouping>
<dxo-data-grid-column-chooser [enabled]="true"></dxo-data-grid-column-chooser>
<dxo-data-grid-load-panel [enabled]="true"></dxo-data-grid-load-panel>
<dxi-data-grid-column
dataField="OrderNumber"
caption="Invoice Number"
></dxi-data-grid-column>
<dxi-data-grid-column dataField="OrderDate"></dxi-data-grid-column>
<dxi-data-grid-column dataField="Employee"></dxi-data-grid-column>
<dxi-data-grid-column
dataField="CustomerStoreCity"
caption="City"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="CustomerStoreState"
caption="State"
[groupIndex]="0"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="SaleAmount"
alignment="right"
format="currency"
></dxi-data-grid-column>
<dxo-data-grid-toolbar>
<dxi-data-grid-item location="before">
<div *dxTemplate class="informer">
<div class="count">{{ totalCount }}</div>
<span>Total Count</span>
</div>
</dxi-data-grid-item>
<dxi-data-grid-item location="before" locateInMenu="auto">
<div *dxTemplate>
<dx-select-box
width="225"
[items]="groupingValues"
[inputAttr]="{ 'aria-label': 'Value' }"
displayExpr="text"
valueExpr="value"
value="CustomerStoreState"
(onValueChanged)="toggleGroupColumn($event)"
>
</dx-select-box>
</div>
</dxi-data-grid-item>
<dxi-data-grid-item
location="before"
locateInMenu="auto"
widget="dxButton"
[options]="toggleButtonOptions"
>
</dxi-data-grid-item>
<dxi-data-grid-item
location="after"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
[options]="refreshButtonOptions"
>
</dxi-data-grid-item>
<dxi-data-grid-item name="columnChooserButton"></dxi-data-grid-item>
</dxo-data-grid-toolbar>
</dx-data-grid>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, ViewChild, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import {
DxDataGridModule,
DxDataGridComponent,
} from 'devextreme-angular';
import { DxButtonTypes } from 'devextreme-angular/ui/button';
import { query } from 'devextreme-angular/common/data';
import { DxSelectBoxModule, DxSelectBoxTypes } from 'devextreme-angular/ui/select-box';
import { Service, Order } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxDataGridModule,
DxSelectBoxModule,
],
})
export class AppComponent {
@ViewChild(DxDataGridComponent, { static: false }) dataGrid: DxDataGridComponent;
orders: Order[];
totalCount: number;
expandAll = true;
groupingValues = [{
value: 'CustomerStoreState',
text: 'Grouping by State',
}, {
value: 'Employee',
text: 'Grouping by Employee',
}];
refreshButtonOptions: DxButtonTypes.Properties = {
icon: 'refresh',
text: 'Refresh',
onClick: () => {
this.dataGrid.instance.refresh();
},
};
toggleButtonOptions: DxButtonTypes.Properties = {
text: this.expandAll ? 'Collapse All' : 'Expand All',
width: 136,
onClick: () => {
this.toggleExpandAll();
this.toggleButtonOptions = {
...this.toggleButtonOptions,
text: this.expandAll ? 'Collapse All' : 'Expand All',
};
},
};
constructor(service: Service) {
this.orders = service.getOrders();
this.totalCount = this.getGroupCount('CustomerStoreState');
}
getGroupCount(groupField: string) {
return query(this.orders)
.groupBy(groupField)
.toArray().length;
}
toggleGroupColumn(e: DxSelectBoxTypes.ValueChangedEvent) {
this.dataGrid.instance.clearGrouping();
this.dataGrid.instance.columnOption(e.value, 'groupIndex', 0);
this.totalCount = this.getGroupCount(e.value);
}
toggleExpandAll() {
this.expandAll = !this.expandAll;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #gridContainer .informer {
display: grid;
width: 120px;
grid-template-columns: 100%;
padding-right: 20px;
text-align: center;
}
::ng-deep #gridContainer .count {
font-size: 18px;
font-weight: 500;
}
::ng-deep #gridContainer .dx-toolbar-items-container {
min-height: 44px;
}
import { Injectable } from '@angular/core';
export class Order {
ID: number;
OrderNumber: number;
OrderDate: Date;
SaleAmount: number;
Terms: string;
TotalAmount: number;
CustomerStoreState: string;
CustomerStoreCity: string;
Employee: string;
}
const orders: Order[] = [{
ID: 1,
OrderNumber: 35703,
OrderDate: new Date(2024, 3, 10),
SaleAmount: 11800,
Terms: '15 Days',
TotalAmount: 12175,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: new Date(2024, 0, 12),
SaleAmount: 16050,
Terms: '15 Days',
TotalAmount: 16550,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: new Date(2024, 0, 22),
SaleAmount: 14750,
Terms: '15 Days',
TotalAmount: 15250,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: new Date(2024, 1, 7),
SaleAmount: 3725,
Terms: '15 Days',
TotalAmount: 3850,
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: new Date(2024, 2, 11),
SaleAmount: 14200,
Terms: '15 Days',
TotalAmount: 14800,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: new Date(2024, 2, 1),
SaleAmount: 7800,
Terms: '15 Days',
TotalAmount: 8200,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: new Date(2024, 1, 15),
SaleAmount: 20500,
Terms: '15 Days',
TotalAmount: 9100,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: new Date(2024, 1, 4),
SaleAmount: 9050,
Terms: '30 Days',
TotalAmount: 19100,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: new Date(2024, 1, 15),
SaleAmount: 20400,
Terms: '30 Days',
TotalAmount: 20800,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: new Date(2024, 4, 29),
SaleAmount: 6050,
Terms: '30 Days',
TotalAmount: 6250,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: new Date(2024, 1, 6),
SaleAmount: 15850,
Terms: '30 Days',
TotalAmount: 16350,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: new Date(2023, 11, 31),
SaleAmount: 11050,
Terms: '30 Days',
TotalAmount: 11400,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
@Injectable()
export class Service {
getOrders(): Order[] {
return orders;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React, { useCallback, useMemo, useRef, useState } from 'react';
import SelectBox, { type SelectBoxTypes } from 'devextreme-react/select-box';
import DataGrid, {
Grouping, Column, ColumnChooser, LoadPanel, Toolbar, Item,
} from 'devextreme-react/data-grid';
import type { DataGridRef } from 'devextreme-react/data-grid';
import { query } from 'devextreme-react/common/data';
import { orders } from './data.ts';
const countLabel = { 'aria-label': 'Count' };
const groupingValues = [{
value: 'CustomerStoreState',
text: 'Grouping by State',
}, {
value: 'Employee',
text: 'Grouping by Employee',
}];
const getGroupCount = (groupField: string) => query(orders).groupBy(groupField).toArray().length;
const App = () => {
const [expandAll, setExpandAll] = useState(true);
const [totalCount, setTotalCount] = useState(getGroupCount('CustomerStoreState'));
const [groupColumn, setGroupColumn] = useState('CustomerStoreState');
const dataGridRef = useRef<DataGridRef>(null);
const toggleGroupColumn = useCallback((e: SelectBoxTypes.ValueChangedEvent) => {
const newGrouping = e.value;
dataGridRef.current?.instance().clearGrouping();
dataGridRef.current?.instance().columnOption(newGrouping, 'groupIndex', 0);
setTotalCount(getGroupCount(newGrouping));
setGroupColumn(newGrouping);
}, []);
const toggleExpandAll = useCallback(() => {
setExpandAll(!expandAll);
}, [expandAll]);
const toggleButtonOptions = useMemo(() => ({
text: expandAll ? 'Collapse All' : 'Expand All',
width: 136,
onClick: () => toggleExpandAll(),
}), [expandAll, toggleExpandAll]);
const refreshButtonOptions = useMemo(() => ({
icon: 'refresh',
text: 'Refresh',
onClick: () => {
dataGridRef.current?.instance().refresh();
},
}), []);
return (
<DataGrid
id="gridContainer"
ref={dataGridRef}
dataSource={orders}
keyExpr="ID"
showBorders={true}>
<Grouping autoExpandAll={expandAll} />
<ColumnChooser enabled={true} />
<LoadPanel enabled={true} />
<Column dataField="OrderNumber" caption="Invoice Number" />
<Column dataField="OrderDate" />
<Column dataField="Employee" />
<Column dataField="CustomerStoreCity" caption="City" />
<Column dataField="CustomerStoreState" caption="State" groupIndex={0} />
<Column dataField="SaleAmount" alignment="right" format="currency" />
<Toolbar>
<Item location="before">
<div className="informer">
<div className="count">{totalCount}</div>
<span>Total Count</span>
</div>
</Item>
<Item location="before" locateInMenu="auto">
<SelectBox
width="225"
items={groupingValues}
displayExpr="text"
inputAttr={countLabel}
valueExpr="value"
value={groupColumn}
onValueChanged={toggleGroupColumn} />
</Item>
<Item
location="before"
locateInMenu="auto"
widget="dxButton"
options={toggleButtonOptions} />
<Item
location="after"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
options={refreshButtonOptions} />
<Item name="columnChooserButton" />
</Toolbar>
</DataGrid>
);
};
export default App;
import React, {
useCallback, useMemo, useRef, useState,
} from 'react';
import SelectBox from 'devextreme-react/select-box';
import DataGrid, {
Grouping,
Column,
ColumnChooser,
LoadPanel,
Toolbar,
Item,
} from 'devextreme-react/data-grid';
import { query } from 'devextreme-react/common/data';
import { orders } from './data.js';
const countLabel = { 'aria-label': 'Count' };
const groupingValues = [
{
value: 'CustomerStoreState',
text: 'Grouping by State',
},
{
value: 'Employee',
text: 'Grouping by Employee',
},
];
const getGroupCount = (groupField) => query(orders).groupBy(groupField).toArray().length;
const App = () => {
const [expandAll, setExpandAll] = useState(true);
const [totalCount, setTotalCount] = useState(getGroupCount('CustomerStoreState'));
const [groupColumn, setGroupColumn] = useState('CustomerStoreState');
const dataGridRef = useRef(null);
const toggleGroupColumn = useCallback((e) => {
const newGrouping = e.value;
dataGridRef.current?.instance().clearGrouping();
dataGridRef.current?.instance().columnOption(newGrouping, 'groupIndex', 0);
setTotalCount(getGroupCount(newGrouping));
setGroupColumn(newGrouping);
}, []);
const toggleExpandAll = useCallback(() => {
setExpandAll(!expandAll);
}, [expandAll]);
const toggleButtonOptions = useMemo(
() => ({
text: expandAll ? 'Collapse All' : 'Expand All',
width: 136,
onClick: () => toggleExpandAll(),
}),
[expandAll, toggleExpandAll],
);
const refreshButtonOptions = useMemo(
() => ({
icon: 'refresh',
text: 'Refresh',
onClick: () => {
dataGridRef.current?.instance().refresh();
},
}),
[],
);
return (
<DataGrid
id="gridContainer"
ref={dataGridRef}
dataSource={orders}
keyExpr="ID"
showBorders={true}
>
<Grouping autoExpandAll={expandAll} />
<ColumnChooser enabled={true} />
<LoadPanel enabled={true} />
<Column
dataField="OrderNumber"
caption="Invoice Number"
/>
<Column dataField="OrderDate" />
<Column dataField="Employee" />
<Column
dataField="CustomerStoreCity"
caption="City"
/>
<Column
dataField="CustomerStoreState"
caption="State"
groupIndex={0}
/>
<Column
dataField="SaleAmount"
alignment="right"
format="currency"
/>
<Toolbar>
<Item location="before">
<div className="informer">
<div className="count">{totalCount}</div>
<span>Total Count</span>
</div>
</Item>
<Item
location="before"
locateInMenu="auto"
>
<SelectBox
width="225"
items={groupingValues}
displayExpr="text"
inputAttr={countLabel}
valueExpr="value"
value={groupColumn}
onValueChanged={toggleGroupColumn}
/>
</Item>
<Item
location="before"
locateInMenu="auto"
widget="dxButton"
options={toggleButtonOptions}
/>
<Item
location="after"
locateInMenu="auto"
showText="inMenu"
widget="dxButton"
options={refreshButtonOptions}
/>
<Item name="columnChooserButton" />
</Toolbar>
</DataGrid>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const orders = [{
ID: 1,
OrderNumber: 35703,
OrderDate: new Date(2024, 3, 10),
SaleAmount: 11800,
Terms: '15 Days',
TotalAmount: 12175,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: new Date(2024, 0, 12),
SaleAmount: 16050,
Terms: '15 Days',
TotalAmount: 16550,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: new Date(2024, 0, 22),
SaleAmount: 14750,
Terms: '15 Days',
TotalAmount: 15250,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: new Date(2024, 1, 7),
SaleAmount: 3725,
Terms: '15 Days',
TotalAmount: 3850,
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: new Date(2024, 2, 11),
SaleAmount: 14200,
Terms: '15 Days',
TotalAmount: 14800,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: new Date(2024, 2, 1),
SaleAmount: 7800,
Terms: '15 Days',
TotalAmount: 8200,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: new Date(2024, 1, 15),
SaleAmount: 20500,
Terms: '15 Days',
TotalAmount: 9100,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: new Date(2024, 1, 4),
SaleAmount: 9050,
Terms: '30 Days',
TotalAmount: 19100,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: new Date(2024, 1, 15),
SaleAmount: 20400,
Terms: '30 Days',
TotalAmount: 20800,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: new Date(2024, 4, 29),
SaleAmount: 6050,
Terms: '30 Days',
TotalAmount: 6250,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: new Date(2024, 1, 6),
SaleAmount: 15850,
Terms: '30 Days',
TotalAmount: 16350,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: new Date(2023, 11, 31),
SaleAmount: 11050,
Terms: '30 Days',
TotalAmount: 11400,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const orders = [
{
ID: 1,
OrderNumber: 35703,
OrderDate: new Date(2024, 3, 10),
SaleAmount: 11800,
Terms: '15 Days',
TotalAmount: 12175,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
},
{
ID: 4,
OrderNumber: 35711,
OrderDate: new Date(2024, 0, 12),
SaleAmount: 16050,
Terms: '15 Days',
TotalAmount: 16550,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
},
{
ID: 5,
OrderNumber: 35714,
OrderDate: new Date(2024, 0, 22),
SaleAmount: 14750,
Terms: '15 Days',
TotalAmount: 15250,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 7,
OrderNumber: 35983,
OrderDate: new Date(2024, 1, 7),
SaleAmount: 3725,
Terms: '15 Days',
TotalAmount: 3850,
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
},
{
ID: 9,
OrderNumber: 36987,
OrderDate: new Date(2024, 2, 11),
SaleAmount: 14200,
Terms: '15 Days',
TotalAmount: 14800,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 11,
OrderNumber: 38466,
OrderDate: new Date(2024, 2, 1),
SaleAmount: 7800,
Terms: '15 Days',
TotalAmount: 8200,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
},
{
ID: 14,
OrderNumber: 39420,
OrderDate: new Date(2024, 1, 15),
SaleAmount: 20500,
Terms: '15 Days',
TotalAmount: 9100,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
},
{
ID: 15,
OrderNumber: 39874,
OrderDate: new Date(2024, 1, 4),
SaleAmount: 9050,
Terms: '30 Days',
TotalAmount: 19100,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 18,
OrderNumber: 42847,
OrderDate: new Date(2024, 1, 15),
SaleAmount: 20400,
Terms: '30 Days',
TotalAmount: 20800,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
},
{
ID: 19,
OrderNumber: 43982,
OrderDate: new Date(2024, 4, 29),
SaleAmount: 6050,
Terms: '30 Days',
TotalAmount: 6250,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 29,
OrderNumber: 56272,
OrderDate: new Date(2024, 1, 6),
SaleAmount: 15850,
Terms: '30 Days',
TotalAmount: 16350,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 30,
OrderNumber: 57429,
OrderDate: new Date(2023, 11, 31),
SaleAmount: 11050,
Terms: '30 Days',
TotalAmount: 11400,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gridContainer .informer {
display: grid;
width: 120px;
grid-template-columns: 100%;
padding-right: 20px;
text-align: center;
}
#gridContainer .count {
font-size: 18px;
font-weight: 500;
}
#gridContainer .dx-toolbar-items-container {
min-height: 44px;
}